// UserHiveTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "UserHiveTest.h"
#include "UserHiveTestDlg.h"

#include "UserRegHive.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CUserHiveTestDlg dialog

CUserHiveTestDlg::CUserHiveTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUserHiveTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUserHiveTestDlg)
	m_User = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CUserHiveTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUserHiveTestDlg)
	DDX_Text(pDX, IDC_USER, m_User);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CUserHiveTestDlg, CDialog)
	//{{AFX_MSG_MAP(CUserHiveTestDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_Load, OnLoad)
	ON_BN_CLICKED(IDC_UNLOAD, OnUnload)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUserHiveTestDlg message handlers

BOOL CUserHiveTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CUserHiveTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CUserHiveTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CUserHiveTestDlg::OnLoad() 
{
	// TODO: Add your control notification handler code here
    TCHAR szUserName[256];
    TCHAR szUserRegHiveSid[256];

    UpdateData( TRUE );

    _tcscpy( szUserName, m_User );

    if ( LoadHiveForUser( szUserName, szUserRegHiveSid, ( sizeof( szUserRegHiveSid ) / sizeof( TCHAR )) ) == FALSE )
    {
        MessageBox( "Failed to load the user registry hive.", "Error" );
    }

    csSID = CString( szUserRegHiveSid );
}

void CUserHiveTestDlg::OnUnload() 
{
	// TODO: Add your control notification handler code here

    if ( UnLoadHiveForSid( csSID ) == FALSE )
    {
        MessageBox( "Failed to unload the user registry hive.", "Error" );
    }
    else
    {
        csSID.Empty();
    }
}
