/*///////////////////////////////////////////////////////////////////////
//                          SOURCE SAVE HEADER                         //
/////////////////////////////////////////////////////////////////////////
// Revision #    : $Revision:: 2                    $                  //
// Last change by: $Author:: Rkp                    $                  //
// Date & Time   : $Date:: 4/20/00 5:34p            $                  //
///////////////////////////////////////////////////////////////////////*/

#ifdef __USERHIVE_EXPORTS
#define IS_HIVE_API __declspec(dllexport)
#else
#define IS_HIVE_API __declspec(dllimport)
#endif

#define MAX_KEY_NAME_LENGTH  1024
#define MAX_KEY_VALUE_LENGTH 1024
#define MAX_DATA_EXPANSION 10000

#define REG_WIN_USERS       TEXT( "SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\ProfileList" )
#define REG_PROF_PATH       TEXT( "ProfileImagePath" )


IS_HIVE_API LONG WINAPI LoadHiveForUser( LPCTSTR szUser, 
                                         LPTSTR lpszSid, 
                                         LONG dwSidBufLen );

IS_HIVE_API LONG WINAPI LoadHiveForSid( LPCTSTR lpszSid );

IS_HIVE_API LONG WINAPI UnLoadHiveForSid( LPCTSTR lpszSid );
